IDRegistry.genItemID("appleSapling");
Item.createItem("appleSapling", "Apple Tree Sapling", {name: "appleSapling", data: 0});
Item.registerUseFunction("appleSapling", function(coords, item, tile){
	var place = coords.relative;
	var tile1 = World.getBlock(place.x, place.y, place.z);
	var tile2 = World.getBlock(place.x, place.y - 1, place.z);
	
	if (GenerationUtils.isTransparentBlock(tile1.id) && TREE_SAPLING_GROUND_TILES[tile2.id]){
		World.setBlock(place.x, place.y, place.z, BlockID.appleTreeSapling);
		World.addTileEntity(place.x, place.y, place.z);
		Player.setCarriedItem(item.id, item.count - 1, item.data);
	}
});

PlantModel.tree(BlockID.appleTreeSapling,0);

IDRegistry.genItemID("appleMini");
Item.createItem("appleMini", " Apple", {name: "appleBlock", meta: 0},{});

Item.registerUseFunction("appleMini", function(coords, item, tile){
	var place = coords.relative;
	World.setBlock(place.x,place.y,place.z,BlockID.appleBlock);
	World.addTileEntity(place.x,place.y,place.z);
});

IDRegistry.genBlockID("appleTreeSapling");
Block.createBlock("appleTreeSapling", [
	{name: "Apple Tree Sapling", texture: [["empty", 0], ["empty", 0], ["appleSapling", 0]], inCreative: false}
],BLOCK_TYPE_PLANT);

TileEntity.registerPrototype(BlockID.appleTreeSapling,saplingPROTO);

Harvest.registerDestroy("appleTreeSapling",ItemID.appleSapling);

Callback.addCallback("PostLoaded", function(){
	Recipes.addShaped({id: ItemID.appleSapling, count: 1, data: 0}, [
		"yx",
		"",
		""
	], ['x', 260,0,"y",6,0]);
});